#!/usr/bin/env python
from urllib import urlopen

def main(line, ld, conf):
    d = False
    if '-d' in line: d = True
    if len(line) > 1:
        print 'Searching %s for %s...' % (conf.search_engine['name'], ' '.join(line[1:]))
        queryurl = conf.search_engine['url'] % ' '.join(line[1:])
        
        queryurl = queryurl.replace('+', '%2B').replace(' ', '+')
        try: raw = urlopen(queryurl).read()
        except IOError as e: 
            debug = 'error ' + str(e)
            if conf.developer_mode or d: debug += ' (url: %s)' % queryurl
            try: errno = str(e.strerror).split('[Errno ')[1].split(']')[0]
            except IndexError: errno = e.errno
            if errno == 110 or errno == '110': return 'Connection timed out. Check your internet connection and firewall(s)'
            return debug
        except KeyboardInterrupt: return 'Interrupted'
        tmp = open(ld + '/dostmp.py', 'w')
        tmp.write('data = ' + raw)
        tmp.close()
        
        import dostmp
        reload(dostmp)
        
        resulted = False
        
        if dostmp.data.get('Definition'): 
            print 'Definition:', dostmp.data.get('Definition')
            resulted = True
        if dostmp.data.get('Answer'): 
            print 'Answer:', dostmp.data.get('Answer')
            resulted = True
        if dostmp.data.get('AbstractText'): 
            print 'Abstract Text:', dostmp.data.get('AbstractText')
            resulted = True
        if dostmp.data.get('Abstract') and dostmp.data.get('Abstract') != dostmp.data.get('AbstractText'): 
            print 'Abstract:', dostmp.data.get('Abstract')
            resulted = True
            
        if resulted: return

        if dostmp.data.get('RelatedTopics'):
            print 'Related topics:'
            for res in dostmp.data.get('RelatedTopics'):
                resulted = True
                print res.get('Text')
        if resulted: return
        
        # print every value
        for key in dostmp.data.keys():
            if dostmp.data[key]: print key + ':', dostmp.data[key]
                
                
class conf: # a quick class to simulate the configuration module for running without DOSprompt
    search_engine = {'name': 'DuckDuckGo', 'url': 'https://api.duckduckgo.com/?q=%s&o=json'}
    
if __name__ == '__main__':
    import sys, os
    main(sys.argv, os.getcwd(), conf)
